%define name krb5-fermi-config
%define path /usr/krb5
%define version 1.7
%define release 90x.7

Summary: Configuration scripts to get Fermize your Kerberos Machine
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{name}-%{version}.tar.gz
Copyright: MIT, freely distributable.
URL: http://web.mit.edu/kerberos/www/
Prereq: fileutils krb5-workstation-fermi
Group: Fermi
Packager: Troy Dawson <dawson@fnal.gov>

%description
Kerberos V5 is a trusted-third-party network authentication system,
which can improve your network's security by eliminating the insecure
practice of cleartext passwords.
The config set's up config files so that a machine is ready to
be in Fermilab's kerberos realm


%changelog
* Tue Nov 11 2003 Troy Dawson <dawson@fnal.gov>
- Put back in the krb.conf, but with proper settings, and triggers

* Tue Oct 04 2003 Troy Dawson <dawson@fnal.gov>
- Cleaned out krb.conf so it quits messing things up.

* Tue Oct 04 2003 Troy Dawson <dawson@fnal.gov>
- Converted to krb5conf 1.7.  I had missed a few things the first time

* Thu Sep 25 2003 Troy Dawson <dawson@fnal.gov>
- Added triggers for the xinetd configs

* Mon Apr 07 2003 Troy Dawson <dawson@fnal.gov>
- Took out the check that took krb.conf completely out.

* Wed Apr 02 2003 Troy Dawson <dawson@fnal.gov>
- Took /etc/krb.conf out

* Fri Aug 09 2002 Troy Dawson <dawson@fnal.gov>
- Changed the requires, put in a check before it does ssh config

* Fri May 24 2002 Troy Dawson <dawson@fnal.gov>
- Fixed a bug in the krb5.conf template (removed two 4's)

* Tue May 07 2002 Troy Dawson <dawson@fnal.gov>
- Made changes to the config xinetd script

* Mon May 06 2002 Troy Dawson <dawson@fnal.gov>
- Configured to use the krb5conf v1_6 stuff

* Thu Oct 25 2001 Troy Dawson <dawson@fnal.gov>
- Changed spec file so that it moves the /etc/krb5.conf file

* Thu Oct 25 2001 Troy Dawson <dawson@fnal.gov>
- Changed the krb5.conf.template file so that the Pam part was first, 
also lengthened ticket time
- Edited the spec file so that it doesn't automatically move the /etc/krb5.conf file

* Tue Oct 2 2001 Troy Dawson <dawson@fnal.gov>
- Made changes for pam usage in krb.conf and krb5.conf
- Also removed the linking of /usr/krb5 and /usr/kerberos

* Mon Aug 27 2001 Troy Dawson <dawson@fnal.gov>
- Upgraded from krb5conf 1.5.  Also put in changes for xinetd.

* Tue Jun 12 2001 Troy Dawson <dawson@fnal.gov>
- Made improvements to the makehostkeys script.  I also have it check 
  for the varias files (sshd_config, services) before modifying them.

* Tue Jun 5 2001 Troy Dawson <dawson@fnal.gov>
- The config-inetd.conf script has been changed to look for services
  that have a kerberos equal.  If these services were originally turned
  off, then the kerberized version is turned off.  I also took out the
  keytab-convert program, as this is dependant on one particular flavor
  of fermi kerberos.

* Tue May 22 2001 Troy Dawson <dawson@fnal.gov>
- I added the keytab-convert program into the config rpm, with it's
  corresponding manpage.  It will also be in the normal kerberos rpm
  but in the bin area.

* Mon May 21 2001 Troy Dawson <dawson@fnal.gov>
- I changed things to the version 1.4.  I also added the config-sshd_config
  script, as well as the config-hostkeys script.

* Wed May 9 2001 Troy Dawson <dawson@fnal.gov>
- I finished with the config-services and config-inetd.conf scripts.
  I also changed how the /usr/krb5 and /usr/kerberos were linked.

* Wed May 2 2001 Troy Dawson <dawson@fnal.gov>
- I put the raw scripts into the package from Fermi.  These will
  need to be rewritten so that they don't depend on Fermi packages.


%prep
%setup


%install
install -m 0755 -d %{path}/config
install -m 0755 -d %{path}/man
install -m 0755 -d %{path}/man/man5

install -m 0744 config-krb5.conf %{path}/config/config-krb5.conf
install -m 0744 config-inetd.conf %{path}/config/config-inetd.conf
install -m 0744 config-xinetd %{path}/config/config-xinetd
install -m 0744 config-services %{path}/config/config-services
install -m 0744 config-sshd_config %{path}/config/config-sshd_config
install -m 0744 config-hostkeys %{path}/config/config-hostkeys
install -m 0744 config-hostkeys %{path}/config/makehostkeys
install -m 0644 inetd.conf.template %{path}/config/inetd.conf.template
install -m 0644 inetd.conf.wrapped.template %{path}/config/inetd.conf.wrapped.template
install -m 0644 krb5.conf.template %{path}/config/krb5.conf.template
install -m 0644 services.template %{path}/config/services.template
install -m 0644 sshd_config.template %{path}/config/sshd_config.template
install -m 0644 sshd_config.weak.template %{path}/config/sshd_config.weak.template
install -m 0644 xinetd.template %{path}/config/xinetd.template
install -m 0644 ftp.xinetd %{path}/config/ftp.xinetd
install -m 0644 telnet.xinetd %{path}/config/telnet.xinetd
install -m 0644 klogin.xinetd %{path}/config/klogin.xinetd
install -m 0644 eklogin.xinetd %{path}/config/eklogin.xinetd
install -m 0644 kshell.xinetd %{path}/config/kshell.xinetd
install -m 0644 ftp.xinetd.on %{path}/config/ftp.xinetd.on
install -m 0644 telnet.xinetd.on %{path}/config/telnet.xinetd.on
install -m 0644 klogin.xinetd.on %{path}/config/klogin.xinetd.on
install -m 0644 eklogin.xinetd.on %{path}/config/eklogin.xinetd.on
install -m 0644 kshell.xinetd.on %{path}/config/kshell.xinetd.on
install -m 0644 krb.conf /etc/krb.conf.fermi

install -m 0644 man/keytab-convert.5 %{path}/man/man5/keytab-convert.5
install -m 0644 man/krb5conf.5 %{path}/man/man5/krb5conf.5

%post 
mv /etc/krb5.conf /etc/krb5.conf.save.%{name}.%{version}.%{release}
%{path}/config/config-krb5.conf %{version}
if [ -f /etc/krb.conf ] ; then
	echo "Fixing /etc/krb.conf"
	if ! [ -s /etc/krb.conf.save.%{name}.%{version}.%{release} ] ; then
		mv -f /etc/krb.conf /etc/krb.conf.save.%{name}.%{version}.%{release}
	fi
	cp -f /etc/krb.conf.fermi /etc/krb.conf
fi
if [ -f /etc/inetd.conf ] ; then
	%{path}/config/config-inetd.conf %{version}
fi
if [ -d /etc/xinetd.d ] ; then
	%{path}/config/config-xinetd %{version}
fi
%{path}/config/config-services %{version}
if [ -f /etc/sshd_conf ] ; then
	%{path}/config/config-sshd_config %{version}
fi
echo "Your computer has been configured to run kerberos"
echo "If you need a host priciple you should run '%{path}/config/makehostkeys'"

%preun
if [ "$1" = "0" ] ; then
	echo "We are in the pre-un and running"
fi

%triggerin -- krb5-workstation
if [ -d /etc/xinetd.d ] ; then
	%{path}/config/config-xinetd %{version} >> /tmp/fermi.krb5.config.xinetd
fi

%triggerin -- krbafs
if [ -f /etc/krb.conf ] ; then
	if ! [ -s /etc/krb.conf.save.%{name}.%{version}.%{release} ] ; then
		mv -f /etc/krb.conf /etc/krb.conf.save.%{name}.%{version}.%{release}
	fi
	cp -f /etc/krb.conf.fermi /etc/krb.conf
fi


%triggerpostun -- krb5-workstation
if [ -d /etc/xinetd.d ] ; then
	%{path}/config/config-xinetd %{version} >> /tmp/fermi.krb5.config.xinetd
fi


%files
%dir %{path}
%dir %{path}/config
%dir %{path}/man
%dir %{path}/man/man5

%{path}/config/config-krb5.conf
%{path}/config/config-inetd.conf
%{path}/config/config-xinetd
%{path}/config/config-services
%{path}/config/config-sshd_config
%{path}/config/config-hostkeys
%{path}/config/makehostkeys
%{path}/config/inetd.conf.template
%{path}/config/inetd.conf.wrapped.template
%{path}/config/krb5.conf.template
%{path}/config/services.template
%{path}/config/sshd_config.template
%{path}/config/sshd_config.weak.template
%{path}/config/xinetd.template
%{path}/config/ftp.xinetd
%{path}/config/telnet.xinetd
%{path}/config/klogin.xinetd
%{path}/config/eklogin.xinetd
%{path}/config/kshell.xinetd
%{path}/config/ftp.xinetd.on
%{path}/config/telnet.xinetd.on
%{path}/config/klogin.xinetd.on
%{path}/config/eklogin.xinetd.on
%{path}/config/kshell.xinetd.on
/etc/krb.conf.fermi
